/* 2053, Fri 25 Jul 03 (PST)

   F64_TEST.C:  Test 64-bit get/put routines

   Copyright (C) 1997-2003 by Nevil Brownlee
   CAIDA | University of Auckland */

/*
 * $Log: f64_test.c,v $
 * Revision 1.4  2003/12/08 22:01:55  uid512
 * First production release of NeTraMet++
 *
 * Revision 1.1.1.2.2.9  2002/06/29 01:55:40  nevil
 * Miscellaneous fixes for warnings found by Compaq Unix cc
 *
 * Revision 1.1.1.2.2.3  2000/06/06 03:38:07  nevil
 * Combine NEW_ATR with TCP_ATR, various bug fixes
 *
 * Revision 1.1.1.2  1999/10/03 21:06:13  nevil
 * *** empty log message ***
 *
 * Revision 1.1.1.1.2.1  1999/01/08 01:38:27  nevil
 * Distribution file for 4.3b7
 *
 * Revision 1.1.1.1  1998/11/16 03:57:26  nevil
 * Import of NeTraMet 4.3b3
 *
 * Revision 1.1.1.1  1998/11/16 03:22:00  nevil
 * Import of release 4.3b3
 *
 * Revision 1.1.1.1  1998/10/28 20:31:23  nevil
 * Import of NeTraMet 4.3b1
 *
 * Revision 1.1.3.2  1998/10/18 23:44:02  nevil
 * Added Nicolai's patches, some 'tidying up' of the source
 *
 * Revision 1.1.3.1  1998/10/13 02:48:15  nevil
 * Import of Nicolai's 4.2.2
 *
 * Revision 1.1.1.1  1998/08/24 12:09:28  nguba
 * NetraMet 4.2 Original Distribution
 *
 * Revision 1.3  1998/05/07 04:28:53  rtfm
 * Implement NetFlowMet, the Cisco NetFlow RTFM meter
 */

#if HAVE_CONFIG_H
#include <ntm_conf.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ausnmp.h"
#include "asn1.h"
/* #include "nmc.h" */
#define EXTERN
#include "nmc_c64.h"

void test(counter64 *c)
{
   char buf[50], *bp;
   counter64 z;
   bp = putc64(buf, c);
   *bp = '\0';
   printf(" >> %s  len=%d\n", buf, bp-buf);
   bp = getc64(&z, buf);
#if SIZEOF_LONG == 8  /* e.g. Alpha */
   printf(" << %lx  len=%d\n", z, bp-buf);
#elif SIZEOF_LONG_LONG == 8  /* e.g. Pentium */
   printf(" << %llx  len=%d\n", z, bp-buf);
#else SIZEOF_LONG == 4
   printf(" << %lx %lx  len=%d\n", z.high,z.low, bp-buf);
#endif
   }

int main(int argc,char *argv[])
{
   counter64 t;
   counter64 cc, m;
   int x, r;

#if WORDS_BIGENDIAN
   printf("WORDS_BIGENDIAN = 1");
#else
   printf("WORDS_BIGENDIAN = 0");
#endif
   printf(", SIZEOF_LONG = %d\n",SIZEOF_LONG); 


#if SIZEOF_LONG == 8  /* e.g. Alpha */
   cc = 0;
   test(&cc);
   cc = 1;
   for (x = 0; x != 10; ++x) {
      cc *= 100;
      printf("%2d:  %lx\n", x+1, cc);

#elif SIZEOF_LONG_LONG == 8  /* e.g. Pentium */
   cc = 0;
   test(&cc);
   cc = 1;
   for (x = 0; x != 10; ++x) {
      cc *= 100;
      printf("%2d:  %llx\n", x+1, cc);

#else SIZEOF_LONG == 4
   cc.high = cc.low = 0;
   test(&cc);

   cc.high = 0;  cc.low = 1;
   for (x = 0; x != 10; ++x) {
      c64timesu16((union u64 *)&m, (union u64 *)&cc, 100);
      memcpy(&cc, &m, sizeof(counter64));
      printf("%2d:  %lx %lx\n", x+1, cc.high,cc.low);
#endif

      test(&cc);
      }
   }

#if 0  /* Sample output */

/home/nevil/ntm-50/src/manager> ./f64_test
WORDS_BIGENDIAN = 0, SIZEOF_LONG = 4
 >> 0  len=1
 << 0  len=1
 1:  64
 >> 100  len=3
 << 64  len=3
 2:  2710
 >> 10000  len=5
 << 2710  len=5
 3:  f4240
 >> 1000000  len=7
 << f4240  len=7
 4:  5f5e100
 >> 100000000  len=9
 << 5f5e100  len=9
 5:  2540be400
 >> 10000000000  len=11
 << 2540be400  len=11
 6:  e8d4a51000
 >> 1000000000000  len=13
 << e8d4a51000  len=13
 7:  5af3107a4000
 >> 100000000000000  len=15
 << 5af3107a4000  len=15
 8:  2386f26fc10000
 >> 10000000000000000  len=17
 << 2386f26fc10000  len=17
 9:  de0b6b3a7640000
 >> 1000000000000000000  len=19
 << de0b6b3a7640000  len=19
10:  6bc75e2d63100000
 >> 7766279631452241920  len=19
 << 6bc75e2d63100000  len=19

#endif
