/* gcc -o tt -lpthread -lm semaphore.o t-test.c */

/* Nevil's semaphore test program:  22 May 02 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <pthread.h>
#include "threads/semaphore.h"

void *producer(void *arg);
void *consumer(void *arg);

int buffer = 0;
Semaphore buf_full;
Semaphore buf_empty;

double x;
void pause(int s)
{  int j;
   for (j = 0; j != s*100000; ++j) {
     x = sin((double)j/200000.0);
      }
   }

void *producer(void *arg)
{
   for (;;) {
      ++buffer;
      printf(" +%d", buffer);  fflush(stdout);
      pause(3);
      printf(" +f"); fflush(stdout);  /*t*/
      semaphore_up(&buf_full);

      printf(" :e"); fflush(stdout);  /*t*/
      semaphore_down(&buf_empty);  /* Block until semaphore > 0 */
      printf(" -e"); fflush(stdout);  /*t*/
      }
   }

void *consumer(void *arg)
{
   int pme_buf;
   for (;;) {
      printf(" :f"); fflush(stdout);  /*t*/
      semaphore_down(&buf_full);  /* Block until semaphore > 0 */
      printf(" -f"); fflush(stdout);  /*t*/

      pme_buf = buffer;
      printf(" +e"); fflush(stdout);  /*t*/
      semaphore_up(&buf_empty);

      printf(" -%d", pme_buf);  fflush(stdout);
      /*      pause(2); /* */
      }
   }


int main(int argc, char *argv[])
{
   pthread_t consumer_th;

   semaphore_init(&buf_full);
   semaphore_init(&buf_empty);

   semaphore_decrement(&buf_full);  /* Start with both threads blocked */
   semaphore_decrement(&buf_empty);

   pthread_create(&consumer_th, NULL, consumer, NULL);

   producer(NULL);
   } 
